import dds
import ddsutil
import std_msgs.Header_.std_msgs.msg.dds_
import struct

class Image___TypeSupport(dds.TypeSupport):

    _typename = 'sensor_msgs::msg::dds_::Image_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="sensor_msgs"><Module name="msg"><Module name="dds_"><Struct name="Image_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="height_"><ULong/></Member><Member name="width_"><ULong/></Member><Member name="encoding_"><String/></Member><Member name="is_bigendian_"><Octet/></Member><Member name="step_"><ULong/></Member><Member name="data_"><Sequence><Octet/></Sequence></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(Image___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(Image_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, Image_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = Image_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class Image_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return Image___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs.Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def height_(self):
        '''
        a DDS unsigned long value
        @rtype: int
        '''
        return self._height__

    _height__checker = ddsutil._ulong_checker
    @height_.setter
    def height_(self, value):
        self._height__checker(value)
        self._height__ = value

    @property
    def width_(self):
        '''
        a DDS unsigned long value
        @rtype: int
        '''
        return self._width__

    _width__checker = ddsutil._ulong_checker
    @width_.setter
    def width_(self, value):
        self._width__checker(value)
        self._width__ = value

    @property
    def encoding_(self):
        '''
        a DDS string value
        @rtype: str
        '''
        return self._encoding__

    _encoding__checker = ddsutil._str_checker
    @encoding_.setter
    def encoding_(self, value):
        self._encoding__checker(value)
        self._encoding__ = value

    @property
    def is_bigendian_(self):
        '''
        a DDS octet value
        @rtype: int
        '''
        return self._is_bigendian__

    _is_bigendian__checker = ddsutil._octet_checker
    @is_bigendian_.setter
    def is_bigendian_(self, value):
        self._is_bigendian__checker(value)
        self._is_bigendian__ = value

    @property
    def step_(self):
        '''
        a DDS unsigned long value
        @rtype: int
        '''
        return self._step__

    _step__checker = ddsutil._ulong_checker
    @step_.setter
    def step_(self, value):
        self._step__checker(value)
        self._step__ = value

    @property
    def data_(self):
        '''
        a DDS sequence<octet> value
        @rtype: list
        '''
        return self._data__

    _data__checker = ddsutil._seq_checker(0,ddsutil._octet_checker)
    @data_.setter
    def data_(self, value):
        self._data__checker(value)
        self._data__ = value

    _member_attributes = ('header_', 'height_', 'width_', 'encoding_', 'is_bigendian_', 'step_', 'data_')

    def __init__(self, **kwargs):
        ''' Create a Image_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs.Header_.std_msgs.msg.dds_.Header_()
        self.height_ = 0
        self.width_ = 0
        self.encoding_ = ''
        self.is_bigendian_ = 0
        self.step_ = 0
        self.data_ = []
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if Image_._packing_fmt is not None:
            return Image_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs.Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += 'I'
        fmt += 'I'
        fmt += 'P'
        fmt += 'B'
        fmt += 'I'
        fmt += ddsutil._align(fmt, ddsutil._pad_fmt('iiP?'))

        Image_._packing_fmt = ddsutil._pad_fmt(fmt)
        return Image_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs.Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.height_ = data.pop(0)
        self.width_ = data.pop(0)
        self.encoding_ = ddsutil._ptr_to_bytes(data.pop(0)).decode('ISO-8859-1')
        self.is_bigendian_ = data.pop(0)
        self.step_ = data.pop(0)
        self.data_ = ddsutil._deserialize_seq(data, 'B', lambda seq_data: seq_data.pop(0))
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.append(self.height_)
        args.append(self.width_)
        args.append(ddsutil._bytes_to_ptr(self.encoding_.encode('ISO-8859-1')))
        args.append(self.is_bigendian_)
        args.append(self.step_)
        args.extend(ddsutil._serialize_seq(self.data_, 'B', lambda seq_args, v: seq_args.append(v)))
        return args

